/**
 * pbhNX
 */

package hockey;

class Pad {
    double x, y, vx, vy, r;
    double width, height;

    Pad(double r, double width, double height) {
        this.r = r;
        this.width = width;
        this.height = height;
    }

    void set(double x, double y, double vx, double vy) {
        this.x = x;
        this.y = y;
        this.vx = vx;
        this.vy = vy;
    }

    void bound(Disk d, int id) {
        double ex, ey, l, d1, d2;
        l = Math.sqrt((x - d.x)*(x - d.x) + (y - d.y)*(y - d.y)) + 0.01;
        if(l < r + d.r) {
            ex = (x - d.x)/l;
            ey = (y - d.y)/l;
            if(!d.hit_p[id]) {
                d1 = ex*d.vx + ey*d.vy;
                d2 = ex*vx + ey*vy;
                d.x = x - (r + d.r)*ex;
                d.y = y - (r + d.r)*ey;
                d.vx = (d.vx - d1*ex) + (-d.e_p*d1 + (1.0 + d.e_p)*d2)*ex;
                d.vy = (d.vy - d1*ey) + (-d.e_p*d1 + (1.0 + d.e_p)*d2)*ey;
                d.hit_p[id] = true;
            } else {
                if((x < -width/2 + r + d.r/2) && (y < -height/2 + r + d.r/2)) {
                    d.vx = 50.0;
                    d.vy = 50.0;
                } else if((x < -width/2 + r + d.r/2) && (y > height/2 - r - d.r/2)) {
                    d.vx = 50.0;
                    d.vy =-50.0;
                } else if((x > width/2 - r - d.r/2) && (y < -height/2 + r + d.r/2)) {
                    d.vx =-50.0;
                    d.vy = 50.0;
                } else if((x > width/2 - r - d.r/2) && (y > height/2 - r - d.r/2)) {
                    d.vx =-50.0;
                    d.vy =-50.0;
                } else {
                    d.vx += -ex;
                    d.vy += -ey;
                }
            }
        } else if(d.hit_p[id]) {
            d.hit_p[id] = false;
        }
    }
}