/**
 * NX
 */

package library.graphics;

public class Light {
    double[] position, ambient, diffuse, specular;

    public Light() {
        position = new double[3];
        ambient = Array.make(0.3, 0.3, 0.3);
        diffuse = Array.make(0.5, 0.5, 0.5);
        specular = Array.make(0.2, 0.2, 0.2);
    }
    public Light(double[] position) {
        this.position = Array.copy(position);
        ambient = Array.make(0.3, 0.3, 0.3);
        diffuse = Array.make(0.5, 0.5, 0.5);
        specular = Array.make(0.2, 0.2, 0.2);
    }
    public Light(double[] position, double[] ambient, double[] diffuse, double[] specular) {
        this.position = Array.copy(position);
        this.ambient = Array.copy(ambient);
        this.diffuse = Array.copy(diffuse);
        this.specular = Array.copy(specular);
    }

    public void setPosition(double[] position) {
        this.position = Array.copy(position);
    }

    public void setAmbient(double[] ambient) {
        this.ambient = Array.copy(ambient);
    }

    public void setDiffuse(double[] diffuse) {
        this.diffuse = Array.copy(diffuse);
    }

    public void setSpecular(double[] specular) {
        this.specular = Array.copy(specular);
    }
}